#include <stdio.h>
main()
{
    long long br=0,s=0;
    int n,q;
    
    scanf("%d %d",&n,&q);
    
    long long d[n],p[n];
    long long k[q];
    
    for(int i=0;i<n;i++)
    {
        scanf("%lld %lld",&d[i],&p[i]);
    }
    
    for(int j=0;j<q;j++)
    {
        scanf("%lld",&k[j]);
    }
    
    int j;
    for(j=0;j<q;j++)
    {
        long long dan;
        
        for(int i=0,dan=d[0];dan<=k[j];dan++)
        {
            if (dan==d[i])
            {
                s+=p[i];
                i++;
            }
            
            if (s-1>=0)
            {
                br++;
                s--;
            }
        }
        
        printf("%lld\n",br);
        br=0;
        s=0;
    } 
}